/*-----------------------------------------------------------------------*/
/* CI057-B 1sem/2014                                                     */
/* Aluno:                                                                */
/* GRR...                                                                */

#include <stdio.h>
#include <stdlib.h>

#define TRUE    1
#define FALSE   0

typedef long TipoChave;

typedef struct no *ApNo;
typedef struct no {
  TipoChave chave;
  ApNo      esq, dir;
} TipoNo;


/*-----------------------------------------------------------------*/
/* geracao da arvore                                               */

void criaArv(ApNo *raiz){
  *raiz = NULL;
  return;
}

ApNo criaNo( TipoChave k, ApNo esq, ApNo dir ){
  ApNo p;

  p = (ApNo) malloc( sizeof(TipoNo) );
  p->chave = k;
  p->esq = esq;
  p->dir = dir;
  return p;
}

ApNo insere(TipoChave k, ApNo p){
  if( p == NULL ){
    return criaNo( k, NULL, NULL );
  }
  if( k <= p->chave )
    p->esq = insere( k, p->esq );
  else
    p->dir = insere( k, p->dir );
  return p;
}

/*-----------------------------------------------------------------*/
/* impressao da arvore                                             */
/* no formato ( chave (esq) (dir)), onde () representa NULL        */

void imprimeArv(ApNo p){

  if( p == NULL )
    printf("()");
  else{
    printf("(%ld ", p->chave);
    imprimeArv( p->esq );
    imprimeArv( p->dir );
    printf(")");
  }
  return;
}

/*-----------------------------------------------------------------*/

int main(int argc, char *argv[]){
  ApNo raiz;
  TipoChave chave;
  int operacao;

  criaArv( &raiz );

  printf("Insira uma sequencia de chaves. Finalize a sequencia com -1: \n");
  scanf("%ld", &chave );
  while (chave != -1)
  {
    raiz = insere ( chave, raiz ) ;
    scanf("%ld", &chave );
  }

  printf("Arvore \n");
  imprimeArv( raiz );
  printf("\n");

  /*----   chamada das funcoes da lista ----
  printf("%ld \n", somaChave(...));

  printf("%ld \n", valorMinimo(...) );

  ... paiMaior(...)
  imprimeArv( raiz );
  printf("\n");

  ... maiorNaRaiz(...)
  imprimeArv( raiz );
  printf("\n");

  ... ordenaPeloMaior(...)
  imprimeArv( raiz );
  printf("\n");

  ... dobraArvore(...)
  imprimeArv( raiz );
  printf("\n");
   --------------------------------------------- */
  return 0;

}
